stages:
  - linter
  - tests
  - build
  - upload

shellcheck:bullseye:amd64:
  image: amd64/debian:bullseye-slim
  tags:
    - gitlab-org-docker
  stage: linter
  before_script:
    - apt update
    - apt install -y --no-install-recommends shellcheck
  script:
    - shellcheck -x ddbuild
    - shellcheck -x scripts/ddbuild_script.sh

tests:bullseye:amd64:
  image: amd64/debian:bullseye-slim
  tags:
    - gitlab-org-docker
  stage: tests
  services:
    - docker:dind
  variables:
    DOCKER_HOST: tcp://docker:2375
    TMPDIR: "/builds/shared/tmp"
    DDBUILD_DEPS: "dpkg-dev docker.io qemu binfmt-support qemu-user-static"
    TESTS_DEPS: "bats debhelper build-essential"
  before_script:
    - apt update
    - apt install -y --no-install-recommends ${TESTS_DEPS} ${DDBUILD_DEPS}
    - rm -fr reports
    - mkdir reports
    - docker run --rm --privileged multiarch/qemu-user-static --reset -p yes
  script:
    - bats --formatter junit --output reports/ --timing tests
  artifacts:
    when: always
    paths:
      - reports/*
    reports:
      junit: reports/TestReport-ddbuild.bats.xml

build:bullseye:amd64:
  image: amd64/debian:bullseye-slim
  tags:
    - gitlab-org-docker
  stage: build
  before_script:
    - apt update
    - apt install -y --no-install-recommends dpkg-dev debhelper build-essential
    - rm -fr PUB
    - mkdir PUB
  script:
    - dpkg-buildpackage -b --target-arch amd64 --no-sign
    - mv ../ddbuild_* PUB
  artifacts:
    paths:
      - PUB/*

# tags must be X.Y.Z ie /\A\d+\.\d+\.\d+\z/
upload:
  stage: upload
  script:
    - DEB=$(cd PUB ; ls *.deb)
    - VERSION=$(git describe)
    - 'curl --header "JOB-TOKEN: $CI_JOB_TOKEN" --upload-file PUB/${DEB} "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/ddbuild/${VERSION}/${DEB}"'
  only:
    - tags

